##!menu:tools=Erstelle &Filterstatistik
#### killsstat.hsc --- Wertet Hamsterinfomails aus
## Autoren: Michael Jaritz sumi.b.f.use@gmx.de
##          Karl Pflsterer sigurd@12move.de
## Version 2.0

#!load hamster.hsm 
#!load hwindows.hsm 
#!load killsstat.hsm
#!load killsstatdialog.hsm


# Konstanten *******************************************************
# Iniread wegen Plausibilitt

ks_Ini_Vars($ks_dialog _
            || IniRead("", "Killsstat", "$ks_accountname", "0") == "0" _        
            || IniRead("", "Killsstat", "$ks_accountpath", "0") == "0" _
            || IniRead("", "Killsstat", "$ks_filemask", "0")    == "0" _
            || IniRead("", "Killsstat", "$ks_storetime", "a")   == "a" _
            || IniRead("", "Killsstat", "$ks_resultpath", "0")  == "0" _
            || IniRead("", "Killsstat", "$ks_log", "a")         == "a" _
            || IniRead("", "Killsstat", "$ks_purge", "a")       == "a" _
            || IniRead("", "Killsstat", "$ks_user", "0")        == "0" _
            || IniRead("", "Killsstat", "$ks_mail", "a")        == "a" _
            || IniRead("", "Killsstat", "$ks_save", "a")        == "a" _
            || IniRead("", "Killsstat", "$ks_explain", "a")     == "a")

# Pfadprfungen; directorycheck ************************************

if(!DirExists($ks_resultpath))
  MsgBox($ks_mbox_path + $ks_resultpath + $ks_mbox_nexis)
  ks_Dir_make($ks_resultpath)
endif

if(!DirExists($ks_accountpath))
  MsgBox($ks_mbox_user + $ks_accountname + $ks_mbox_nexis)
  error($ks_mbox_error_user)
endif

if(!FileExists($ks_accountpath + "*.msg"))
  MsgBox($ks_mbox_no_msg)
  quit
endif

# Variablen ********************************************************

# $ks_filelist == Liste mit Namen aller *.msg Dateien in $accountpath
# $ks_textlist == Inhalt einer Datei
# $ks_mail_filtlist == Liste der Zeilen in Mailfilt.hst
# $ks_killfilter == kill()-Zeilen in MailFilt.hst
# $ks_kill_match_list == Liste mit Eintrgen, die auf regexp matchen
# $ks_kill_usort_list == unsortierte Liste mit einzigartigen Eintrgen
# und Hufigkeiten als tag
# $ks_kill_sort_list == obige Liste nach tags sortiert
# $ks_ign... dito fr ignore()
# ks_mutnusortlist == unsortierte Liste mit einzigartigen Eintrgen
# und Hufigkeiten als Tag; Eintrge nicht in mailFilt.hst
# ks_mutnsortlist == obige Liste nach tags sortiert
# $ks_lists == Liste mit Namen der Listen, fr die Statistik erstellt
# werden soll
# $date1, $date2; ltestes und neuestes Datum der Notifymails

varset($ks_filelist, ListAlloc())
varset($ks_textlist, ListAlloc())

varset($ks_mailfilt_list, ListAlloc())

varset($ks_killfilter, ListAlloc())
varset($ks_kill_match_list, ListAlloc(true))
varset($ks_kill_usort_list, ListAlloc())
varset($ks_kill_sort_list, ListAlloc())
varset($ks_killsum, 0)

varset($ks_ignofilter, ListAlloc())
varset($ks_igno_match_list, ListAlloc(true))
varset($ks_igno_sort_list, ListAlloc())
varset($ks_igno_usort_list, ListAlloc())
varset($ks_ignosum, 0)

varset($ks_scorfilter, ListAlloc())
varset($ks_scor_match_list, ListAlloc(true))
varset($ks_scor_sort_list, ListAlloc())
varset($ks_scor_usort_list, ListAlloc())
varset($ks_scorsum, 0)

varset($ks_server_match_list, ListAlloc())

varset($ks_mutn_usort_list, ListAlloc())
varset($ks_mutn_sort_list, ListAlloc())
varset($ks_lists, ListAlloc())

varset($date1, 0)
varset($date2, 0)
# Hilfsvariablen; additional variables *****************************
var($i, $ks_noerror, $tmp)

# Unser Programm; The programm ************************************* 

print($ks_print_1)

ListLoad($ks_mailfilt_list, Hampath + "Mailfilt.hst")
ks_Parse_Includes($ks_mailfilt_list)

# mailFilt.hst *****************************************************
ListAdd($ks_lists, $ks_killfilter)
ListAdd($ks_lists, $ks_start_line_reg + $ks_kill_line_reg)
ListAdd($ks_lists, $ks_ignofilter)
ListAdd($ks_lists, $ks_start_line_reg + $ks_igno_line_reg)
ListAdd($ks_lists, $ks_scorfilter)
ListAdd($ks_lists, $ks_start_line_reg + $ks_scor_line_reg)

ks_look_filter($ks_mailfilt_list, $ks_lists)
ListClear($ks_lists)

# Aufrumen / Purge ************************************************
if($ks_purge)
  ks_Purge_notify($ks_accountpath, $ks_filemask, $ks_storetime)
endif

$ks_noerror = ListFiles($ks_filelist, _
             $ks_accountpath + $ks_filemask, true)

if($ks_noerror)
  print($ks_noerror + $ks_print_2)

  # Suchen / Searching *********************************************
  ListAdd($ks_lists, $ks_kill_line_reg)
  ListAdd($ks_lists, $ks_kill_match_list)
  ListAdd($ks_lists, true) # date yes
  ListAdd($ks_lists, $ks_igno_line_reg)
  ListAdd($ks_lists, $ks_igno_match_list)
  ListAdd($ks_lists, true) # date yes
  ListAdd($ks_lists, $ks_scor_line_reg)
  ListAdd($ks_lists, $ks_scor_match_list)
  ListAdd($ks_lists, true) # date yes
  ListAdd($ks_lists, $ks_server_reg)
  ListAdd($ks_lists, $ks_server_match_list)
  ListAdd($ks_lists, false) # date no
  
  for($i, 0, ListCount($ks_filelist) - 1)
    ListLoad($ks_textlist, ListGet($ks_filelist, $i))
    $tmp = ks_Parse_date(ks_Searchlines($ks_textlist, $ks_lists))
    if($tmp > $date2)
      $date2 = $tmp
    endif
    if($tmp < $date1 || $date1 == 0)
      $date1 = $tmp
    endif
  endfor
  ListClear($ks_lists)
  Listfree($ks_textlist)
  Listfree($ks_filelist)

  print($ks_print_3)
  # Zhlen / Counting *********************************************
  $ks_killsum = ks_Del_count_comp_lines($ks_kill_match_list, $ks_kill_usort_list, _
                $ks_killfilter, $ks_mutn_usort_list)

  $ks_ignosum = ks_Del_count_comp_lines($ks_igno_match_list, $ks_igno_usort_list, _
                $ks_ignofilter, $ks_mutn_usort_list)
  
  $ks_scorsum = ks_Del_count_comp_lines($ks_scor_match_list, $ks_scor_usort_list, _
                $ks_scorfilter, $ks_mutn_usort_list)
  
  ks_Count_Server($ks_server_match_list)
  ListFree($ks_killfilter)
  ListFree($ks_ignofilter)
  ListFree($ks_scorfilter)


  # Sortieren / Sorting ********************************************
  ListAdd($ks_lists, $ks_kill_usort_list)
  ListAdd($ks_lists, $ks_kill_sort_list)
  ListAdd($ks_lists, $ks_igno_usort_list)
  ListAdd($ks_lists, $ks_igno_sort_list)
  ListAdd($ks_lists, $ks_scor_usort_list)
  ListAdd($ks_lists, $ks_scor_sort_list)
  ListAdd($ks_lists, $ks_mutn_usort_list)
  ListAdd($ks_lists, $ks_mutn_sort_list)
  
  ks_Sort($ks_lists)
  
  ListClear($ks_lists)
  Listfree($ks_kill_usort_list)
  Listfree($ks_igno_usort_list)
  ListFree($ks_scor_usort_list)
  ListFree($ks_mutn_usort_list)

  # Log? ***********************************************************
  if($ks_log)
    ListAdd($ks_lists, $ks_list_8)
    ListAdd($ks_lists, $ks_kill_sort_list)
    ListAdd($ks_lists, $ks_list_9)
    ListAdd($ks_lists, $ks_igno_sort_list)
    ListAdd($ks_lists, $ks_list_13)
    ListAdd($ks_lists, $ks_scor_sort_list)
    ListAdd($ks_lists, $ks_list_11)
    ListAdd($ks_lists, $ks_server_match_list)
    ListAdd($ks_lists, $ks_list_10)
    ListAdd($ks_lists, $ks_mutn_sort_list)
    
    ks_Print_stat($ks_lists)
    
    ListClear($ks_lists)
  endif
  
  # Statistik schreiben/ write statistics***************************
  ListAdd($ks_lists, $ks_killtitle)
  if($ks_killsum)
    ListAdd($ks_lists, $ks_kill_sort_list)
  else
    ListAdd($ks_kill_sort_list, $ks_list_1)
    ListAdd($ks_lists, $ks_kill_sort_list)
  endif

  ListAdd($ks_lists, $ks_ignotitle)
  if($ks_ignosum)
    ListAdd($ks_lists, $ks_igno_sort_list)
  else
    ListAdd($ks_igno_sort_list, $ks_list_2)
    ListAdd($ks_lists, $ks_igno_sort_list)
  endif
  
  ListAdd($ks_lists, $ks_scortitle)
  if($ks_scorsum)
    ListAdd($ks_lists, $ks_scor_sort_list)
  else
    ListAdd($ks_scor_sort_list, $ks_list_14)
    ListAdd($ks_lists, $ks_scor_sort_list)
  endif
  
  ListAdd($ks_lists, $ks_servertitle)
  ListAdd($ks_lists, $ks_server_match_list)
  
  ListAdd($ks_lists, $ks_mutntitle)
  if(ListCount($ks_mutn_sort_list))
    ListAdd($ks_mutn_sort_list, $CRLF + $CRLF +_
            $ks_list_3 + trim($ks_killsum) + $ks_list_4 + trim($ks_ignosum) + _
            $ks_list_5 + trim($ks_scorsum) + $ks_list_5a + _
            trim($ks_noerror) + $ks_list_6 + $ks_list_6a + ks_Decode_date($date1) + _
            $ks_list_6b + ks_Decode_date($date2))
    
    if($ks_explain)
      ListAdd($ks_mutn_sort_list, $ks_mutnexpl)
    endif
    
    ListAdd($ks_lists, $ks_mutn_sort_list)
  else
    ListAdd($ks_mutn_sort_list, $ks_list_7)
    
    ListAdd($ks_mutn_sort_list, $CRLF + $CRLF +_
            $ks_list_3 + trim($ks_killsum) + $ks_list_4 + trim($ks_ignosum) + _
            $ks_list_5 + trim($ks_scorsum) + $ks_list_5a + _
            trim($ks_noerror) + $ks_list_6 + $ks_list_6a + ks_Decode_date($date1) + _
            $ks_list_6b + ks_Decode_date($date2))
    if($ks_explain)
      ListAdd($ks_mutn_sort_list, $ks_mutnexpl)
    endif
    
    ListAdd($ks_lists, $ks_mutn_sort_list)
  endif
  
  # Mail? **********************************************************
  if($ks_mail)
    print($ks_print_4 + $ks_user)
    ks_Sendmail($ks_lists, $ks_user, $ks_mailsub_stat)
  endif
  
  # File? **********************************************************
  if($ks_save)
    print($ks_print_5 + $ks_resultpath)
    ks_SaveStat($ks_lists, $ks_resultpath, "_matchlist.txt")
  endif
  ListClear($ks_lists)

  # Bewerte mailFilt.hst *******************************************
  print($ks_print_6)
  ListAdd($ks_lists, $ks_kill_sort_list)
  ListAdd($ks_lists, $ks_kill_line_reg)
  ListAdd($ks_lists, $ks_igno_sort_list)
  ListAdd($ks_lists, $ks_igno_line_reg)
  ListAdd($ks_lists, $ks_scor_sort_list)
  ListAdd($ks_lists, $ks_scor_line_reg)
  
  ListLoad($ks_mailfilt_list, Hampath + "Mailfilt.hst")  
  ks_tags_in_filterlist($ks_mailfilt_list, $ks_lists)

  # Titel
  ListInsert($ks_mailfilt_list, 0, _
             "============================================================")
  ListInsert($ks_mailfilt_list, 1, $TAB + $TAB + "mailFilt.hst")
  ListInsert($ks_mailfilt_list, 2, _
             "============================================================")
  ListInsert($ks_mailfilt_list, 3, $TAB + $CRLF + $CRLF)

  ListClear($ks_lists)

  ListAdd($ks_lists, " ")
  ListAdd($ks_lists, $ks_mailfilt_list)
  
  # mail? **********************************************************
  if($ks_mail)
    print($ks_print_9 + $ks_user)
    ks_Sendmail($ks_lists, $ks_user, $ks_mailsub_mFilt)
  endif
  
  # File? **********************************************************
  if($ks_save)
    print($ks_print_10 + $ks_resultpath)
    ks_SaveStat($ks_lists, $ks_resultpath, "_mailfilthst.txt")
  endif
  
endif

ListFree($ks_mailfilt_list)
Listfree($ks_kill_match_list)
Listfree($ks_igno_match_list)
Listfree($ks_scor_match_list)
Listfree($ks_server_match_list)
Listfree($ks_kill_sort_list)
Listfree($ks_igno_sort_list)
ListFree($ks_scor_sort_list)
ListFree($ks_mutn_sort_list)
ListFree($ks_lists)
quit


